import es, os.path, cPickle, math, popuplib, playerlib

from itertools import *

players = {}

info = es.AddonInfo() 
info.name = "Dogtag Hunt" 
info.version = "1.0" 
info.author = "Cyborg" 
info.url = "http://addons.eventscripts.com/addons/view/dogtaghunt" 
info.description = "Kill an enemy with your knife to get his dogtag!" 
es.ServerVar("dogtaghunt_ver", info.version, "Version of Dogtag Hunt this server is currently using.").makepublic()

def load():
    global players
    str_path = es.getAddonPath('dogtaghunt') + '/playersdatabase.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        players = cPickle.load(file_users)
        file_users.close()
    es.regsaycmd('!dtmenu', 'dogtaghunt/dtmenu')
    
    main = popuplib.create('dogtaghunt_main')
    main.addline('Dogtag Hunt v1.0 by Cyborg')
    main.addline('-------------------------------------')
    main.addline('-> 1. Top 10 hunters: total dogtags')
    main.addline('-> 2. Top 10 hunters: unique dogtags')
    main.addline('-> 3. Your dogtag collection')
    main.addline(' ')
    main.addline('0. Exit')
    main.menuselect = mainSelection
    
def dtmenu():
    popuplib.send('dogtaghunt_main', es.getcmduserid())
        
def mainSelection(userid, choice, popupid):
    if int(choice) in range(4,9): popuplib.send(popupid, userid)
    elif int(choice) == 9: popuplib.send(popupid, userid)
    elif int(choice) == 3: dogtagcollection(userid)  
    elif int(choice) == 1:
        top10total = popuplib.create('dogtaghunt_top10total')
        top10total.addline('Top 10 hunters: total dogtags')
        top10total.addline('--------------------------------------')
        for rank, playerid in izip(count(1), isorted(players, key=lambda playerid: players[playerid]['Total'], reverse=True)):
            if players[playerid]["Total"] == 0 or rank == 11: break
            else:
                top10total.addline('%s. %s - %s' %(rank, players[playerid]["Playername"], players[playerid]["Total"]))

        top10total.addline(' ')
        top10total.menuselect = topSelection
        top10total.addline('0. Exit')
        popuplib.send('dogtaghunt_top10total',userid)
    elif int(choice) == 2:
        top10unique = popuplib.create('dogtaghunt_top10unique')
        top10unique.addline('Top 10 hunters: unique dogtags')
        top10unique.addline('----------------------------------------')
        for rank, playerid in izip(count(1), isorted(players,  key=lambda playerid: players[playerid]['Unique'], reverse=True)):
            if players[playerid]["Total"] == 0 or rank == 11: break
            else:
                top10unique.addline('%s. %s - %s' %(rank, players[playerid]["Playername"], players[playerid]["Unique"]))

        top10unique.addline(' ')
        top10unique.menuselect = topSelection
        top10unique.addline('0. Exit')
        popuplib.send('dogtaghunt_top10unique',userid)   
    
def topSelection(userid, choice, popupid):
    if int(choice) in range(1,9): popuplib.send(popupid, userid)
    elif int(choice) == 9: popuplib.send(popupid, userid)
        
def isorted(itr, key=None, reverse=False):
    f = max if reverse else min
    k = {} if key is None else {'key': key}
    itr = list(itr)
    while itr:
        x = f(itr, **k)
        yield x
        itr.remove(x) 
        
def round_start(ev):
    es.msg('#multi', '#green[Dogtag Hunt]#default Kill a human enemy with your knife to get his dogtag!')
    es.msg('#multi', '#green[Dogtag Hunt]#default Say #lightgreen!dtmenu #defaultto view top 10s and your dogtag collection.')
    
def player_spawn(ev):
    userid = playerlib.uniqueid(ev['userid'])
    if not int(ev['es_userteam']) or es.isbot(ev['userid']) or not userid: return
    try:
        players[userid]['Playername'] = es.getplayername(ev['userid'])
    except KeyError:
        players[userid] = {
            'Players': { 
                        },
            'Total': 0,
            'Unique': 0,
            'Playername': es.getplayername(ev['userid'])
        }
 
def round_end(ev):
    global players
    str_path = open(es.getAddonPath('dogtaghunt') + '/playersdatabase.db', 'w')
    cPickle.dump(players, str_path)
    str_path.close()
        
def player_death(ev):
    if ev['weapon'] == 'knife':
        if ev['es_userteam'] != ev['es_attackerteam'] and not es.isbot(ev['attacker']) and not es.isbot(ev['userid']):
            attacker = playerlib.uniqueid(ev['attacker'])
            userid = playerlib.uniqueid(ev['userid'])
            useridname = es.getplayername(ev['userid'])
            es.tell(ev['attacker'], "#multi", '#green[Dogtag Hunt] #defaultYou took the dogtag of#lightgreen %s#default!' %useridname)
            if userid in players[attacker]['Players']: players[attacker]['Players'][userid]['amount'] += 1    
            else:  
                players[attacker]['Players'][userid] = {
                                                                        'amount': 1,
                                                                        'playername': useridname
                                                                     }
                players[attacker]['Unique'] += 1
            players[attacker]['Total'] += 1

def dogtagcollection(userid):
    if popuplib.exists('dogtaghunt_list_%s' %userid): popuplib.delete('dogtaghunt_list_%s' %userid)
    playerlist = []
    namelist = {}
    for dogtagid in isorted(players[playerlib.uniqueid(userid)]['Players'], key=lambda dogtagid: players[dogtagid]['Playername']):
        newentry = '%s - %sx' %(players[dogtagid]['Playername'], players[playerlib.uniqueid(userid)]['Players'][dogtagid]['amount'])
        playerlist.append(newentry)
    dogtaglist = popuplib.easylist('dogtaghunt_list_%s' %userid, playerlist)
    dogtaglist.settitle('Total: %s || Unique: %s' %(players[playerlib.uniqueid(userid)]['Total'], players[playerlib.uniqueid(userid)]['Unique']))
    dogtaglist.send(userid)        